// Copyright (c) 2016, root ext. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

/// Dart Native Access
library dna;

import 'dart-ext:dna';
import 'dart:typed_data';
import 'dart:mirrors';

part 'pointer.dart';
part 'library.dart';

int nCreateCallVM(int size) native "nCreateCallVM";
void nFreeCallVM(int vm) native "nFreeCallVM";

void nArgs(int vm, String signature, List<Object> args) native "nArgs";

dynamic nCall(int vm, int pointer, String signature) native "nCall";

int nLoadLibrary(String name) native "nLoadLibrary";
void nFreeLibrary(int lib) native "nFreeLibrary";
int nFindSymbol(int lib, String name) native "nFindSymbol";

int nDefineStruct(String signature) native "nDefineStruct";
int nBuildStruct(String signature, List<Object> args) native "nBuildStruct";
void nArgStruct(int vm, int struct, int pointer) native "nArgStruct";
int nCallStruct(int vm, int pointer, int struct) native "nCallStruct";

