// Copyright (c) 2016, root ext. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

import 'package:dna/dna.dart';
import 'package:test/test.dart';
import 'dart:io' as io;

void main() {

  group('base tests', () {
    int library;

    setUp(() {
      library = nLoadLibrary('libc.so.6');
    });

    tearDown(() {
      nFreeLibrary(library);
    });

    test('library', () {
      expect(library, isNonZero);
    });

    test('empty vm', () {
      var vm = nCreateCallVM(256);
      expect(vm, isNonZero);
      nFreeCallVM(vm);
    });

    test('linux getpid', () {
      var method = nFindSymbol(library, 'getpid');
      expect(method, isNonZero);
      var vm = nCreateCallVM(256);
      var pid = nCall(vm, method, toSig[ARG_INT]);
      nFreeCallVM(vm);

      expect(pid, isNonZero);
      expect(pid, equals(io.pid));
    });


  });
}
